
var VERSION = "1.03";
var DEBUG = false;
//=========================================================================
// Unicode sliderule
// sburke@cpan.org

var chardata_base = "./data/x";

var scratchy;
var groupy;
var portal;
var portalmode_picker;
var portal_updater_function;
var InsertButtons = [];
var current_group = 0;
var portal_mode_using_chardata = false;
var smart_selection;

var Rangelabels = [
 /* 0x00 */  "Latin-1",
 /* 0x01 */  "Latin",
 /* 0x02 */  "Latin; IPA; spacing accents",
 /* 0x03 */  "Combining accents; Greek; Coptic",
 /* 0x04 */  "Cyrillic",
 /* 0x05 */  "Cyrillic; Armenian; Hebrew",
 /* 0x06 */  "Arabic",
 /* 0x07 */  "Syriac; Thaana",
 '', // 08
 /* 0x09 */  "Devanagari; Bengali",
 /* 0x0A */  "Gurmukhi; Gujarati",
 /* 0x0B */  "Oriya; Tamil",
 /* 0x0C */  "Telugu; Kannada",
 /* 0x0D */  "Malayalam; Sinhala",
 /* 0x0E */  "Thai; Lao",
 /* 0x0F */  "Tibetan",
 /* 0x10 */  "Burmese; Georgian",
 /* 0x11 */  "Hangul jamo",
 /* 0x12 */  "Ethiopic",
 /* 0x13 */  "Ethiopic; Cherokee",
 /* 0x14 */  "Canadian syllabics",
 /* 0x15 */  "Canadian syllabics",
 /* 0x16 */  "Canadian syllabics; Ogham; Runic",
 /* 0x17 */  "Tagalog; Hanunoo; Buhid; Tagbanwa; Khmer",
 /* 0x18 */  "Mongolian",
 /* 0x19 */  "Limbu; Tai Le; Khmer",
 '','','', // 1a 1b 1c
 /* 0x1D */  "Phonetic Extensions",
 /* 0x1E */  "Latin",
 /* 0x1F */  "Greek",
 /* 0x20 */  "General punctuation & symbols",
 /* 0x21 */  "Letterlike symbols; number forms; arrows",
 /* 0x22 */  "Math operators",
 /* 0x23 */  "Miscellaneous technical",
 /* 0x24 */  "Character symbols",
 /* 0x25 */  "Lines, boxes, & shapes",
 /* 0x26 */  "Misc symbols",
 /* 0x27 */  "Dingbats; math symbols; arrows",
 /* 0x28 */  "Braille patterns",
 /* 0x29 */  "Arrows; math symbols",
 /* 0x2A */  "Math operators; symbols; arrows",
 '','','',
 /* 0x2E */  "CJK radicals",
 /* 0x2F */  "Kangxi radicals; CJK patterns",
 /* 0x30 */  "CJK symbols & punctuation; Kana",
 /* 0x31 */  "Bopomofo; Hangul compat. jamo; Kanbun; Kana",
 /* 0x32 */  "Enclosed CJK letters and months",
 /* 0x33 */  "CJK compat",

 // 34-4f:
                            "CJK", "CJK", "CJK", "CJK",
 "CJK", "CJK","CJK", "CJK", "CJK", "CJK", "CJK", "CJK",

 // 4x:
 "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK",
 "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK",

 // 5x:
 "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK",
 "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK",

 // 6x:
 "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK",
 "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK",

 // 7x:
 "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK",
 "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK",

 // 8x:
 "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK",
 "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK",

 // 9x:
 "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK",
 "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK",

 // Ax:
 "Yi",  "CJK", "CJK", "CJK", "CJK", "CJK", "CJK", "CJK",
 "CJK", "CJK", "CJK", "CJK",
   "Hangul syllables",  // 0xAC
   "Hangul syllables",
   "Hangul syllables",
   "Hangul syllables",

 // Bx:
 "Hangul syllables",  "Hangul syllables",  "Hangul syllables",  "Hangul syllables",
 "Hangul syllables",  "Hangul syllables",  "Hangul syllables",  "Hangul syllables",
 "Hangul syllables",  "Hangul syllables",  "Hangul syllables",  "Hangul syllables",
 "Hangul syllables",  "Hangul syllables",  "Hangul syllables",  "Hangul syllables",

 // Cx:
 "Hangul syllables",  "Hangul syllables",  "Hangul syllables",  "Hangul syllables",
 "Hangul syllables",  "Hangul syllables",  "Hangul syllables",  "Hangul syllables",
 "Hangul syllables",  "Hangul syllables",  "Hangul syllables",  "Hangul syllables",
 "Hangul syllables",  "Hangul syllables",  "Hangul syllables",  "Hangul syllables",

 // Dx:
 "Hangul syllables",  "Hangul syllables",  "Hangul syllables",  "Hangul syllables",
 "Hangul syllables",  "Hangul syllables",  "Hangul syllables",  "Hangul syllables",

 /* 0xD8 */
 "High surrogates", "High surrogates", "High surrogates", "High surrogates",
 /* 0xDC */
 "Low surrogates",  "Low surrogates",  "Low surrogates",  "Low surrogates",
 
 // Ex:
 "Private use",  "Private use",  "Private use",  "Private use",
 "Private use",  "Private use",  "Private use",  "Private use",
 "Private use",  "Private use",  "Private use",  "Private use",
 "Private use",  "Private use",  "Private use",  "Private use",

 // Fx:
 "Private use",  "Private use",  "Private use",  "Private use",
 "Private use",  "Private use",  "Private use",  "Private use",
 "Private use",
 
 /* 0xF9+A   */  "CJK", "CJK",
 /* 0xFB+C+D */  "Alphabetic/Arabic presentation forms",
               "Arabic presentation forms",
               "Arabic presentation forms",
 /* 0xFE */  "Variation selectors",
 /* 0xFF */  "Specials; Halfwidth & fullwidth forms"
];

//=========================================================================

function _init_pointers () {
  scratchy = id("scratchy");
  if(! scratchy) { throw "JSUT error: Can't find the target-blank." }

  groupy = id("groupy");
  if(! groupy) { throw "JSUT error: Can't find the group selector." }

  portal = id("portal");
  if(! portal) { throw "JSUT error: Can't find the portal." }
  
  portalmode_picker = id("portalmode");
  if(! portalmode_picker) { throw "JSUT error: Can't find the portal mode selector." }

  var aboutlink = id("aboutlink");
  if(aboutlink) { aboutlink.setAttribute( "title",
    "About Unicode Sliderule v" + VERSION);
  }

  portal.value = "";

  scratchy.value = "";
  scratchy.focus();

  smart_selection = (  // flag for whether the browser is smart
	   'selectionStart'	in scratchy 
	&& 'selectionEnd'	in scratchy
	&& 'setSelectionRange'	in scratchy
  );

  portal_updater_function = _portal_unidecode;
  portal_mode_using_chardata = true;

  return;
}

//==========================================================================

function _gen_buttons () { _gen_buttons_par(); }

function _gen_buttons_par () {
  var t = id("buttonpar");
  if( !t ) { throw "JSUT error: Can't find the buttonpar section." }
  
  var tr;
  for( var i = 0; i < 256; i++ ) {
    var button = document.createElement("input");
    button.setAttribute( "type", "button" );
    button.setAttribute( "class", "letter" );
    button.setAttribute( "value", "_" );
    button.onclick = _make_handler(i);

    InsertButtons.push( button ); 
    t.appendChild(      button );
  }
  
  return;
}

//==========================================================================

function _gen_buttons_table () {
  var t = id("buttongroup");
  if( !t ) { throw "JSUT error: Can't find the button-table." }
  
  var tr;
  for( var i = 0; i < 256; i++ ) {
    var td = document.createElement("td");
    var button = document.createElement("input");
    button.setAttribute( "type", "button" );
    //button.setAttribute( "style", "" );
    button.setAttribute( "class", "letter" );
    button.setAttribute( "value", "_" );
    button.onclick = _make_handler(i);

    InsertButtons.push( button ); 
    
    if( i % 16 == 0 ) {
      tr = document.createElement("tr");
      t.appendChild(tr);
    }
    td.appendChild(button);
    tr.appendChild(td);
  }
  
  return;
}

//==========================================================================

function _gen_pulldowns () {

  for( var i = 0; i < 256; i++ ) {

    var rangelabel = (i in Rangelabels && Rangelabels[i])
     ? (": " + Rangelabels[i]) : '';

    var o = document.createElement("option");
    o.value = i.toString();

    var textlabel = document.createTextNode(
      tohex_xx(i).toUpperCase() + rangelabel
    );
    o.appendChild(textlabel);
    groupy.appendChild(o);
  }  
  return;

}

function _make_handler (lsb) {
  var j = lsb;
  return function () { inserty(j); };  // yes, a closure!
}

function tohex_xx (i) {
  return   i < 16 ? ("0" + i.toString(16)) : i.toString(16);
}

function tohex_xxxx (i) {
  return(
      i < 0x0010 ? ("000" + i.toString(16))
    : i < 0x0100 ? ("00"  + i.toString(16))
    : i < 0x1000 ? ("0"   + i.toString(16))
    : i.toString(16)
  );
}

//=========================================================================

function ev_setgroup (f) {
  if( typeof(groupy.value) == "undefined" ||
    current_group == parseInt(groupy.value)
  ) {
    return;
  }
  current_group = parseInt(groupy.value);
  _update_buttons();
  return;
}

function _update_buttons () {
  //alert("Hi there" + InsertButtons);
  var c;
  var charname;
  var stringform;
  for( var i in InsertButtons ) {
    //alert("To alter: " + i );
    c = (i * 1) + (current_group * 256)
    stringform = String.fromCharCode(c);
    InsertButtons[i].setAttribute( "value", " " + stringform );
      // That space only adds one or two pixels to the box, but it
      //  makes the combining characters (like in in 03) compose right.
    var u = c.toString(16);
    while( u.length < 4 ) { u = "0" + u; }

    charname = Charn(current_group, i); // was: Un(current_group, i);
    if(charname && charname != stringform
       && charname != "[?]"  && charname != "<control>"
    ) {
      charname = ": " + charname;
    } else {
      charname = "";
    }
    
    InsertButtons[i].setAttribute( "title", 
      //"Char " + c.toString() + " (U+" + u + ")" + charname
      "U+" + u + charname
    );


    if(current_group == 0 &&
     ( (c < 0x20) || (c > 0x7f && c < 0xa0) )
    ) {
      InsertButtons[i].style.display = 'none';
    } else {
      InsertButtons[i].style.display = '';
    }
  }
  return;
}

//=========================================================================

// Unidecode access functions:

var U = [];
var Charname = [];
var requests_pending_count = 0;

function Unchar (bigc) { return    Un( (bigc >>> 8) , (bigc & 0xff) ) }
function CharnC (bigc) { return Charn( (bigc >>> 8) , (bigc & 0xff) ) }

function Un (block, charnum) {
  if(!U[block]) { _load_wad(block) }
  if( charnum in U[block] ) { return U[block][charnum] }
  else return "";
}

function Charn (block, charnum) {
  if(!Charname[block]) { _load_wad(block) }
  if( charnum in Charname[block] ) { return Charname[block][charnum] }
  else return "";
}

function _load_wad (block) {  // "On the moon, Meatwad, on the moon..."
  var uri_toload = chardata_base + tohex_xx(block) + ".js";
  if(DEBUG) alert("Loading " + uri_toload);

  U[block] = []; Charname[block] = [];
   // This ^^^^^, if nothing else, will stop _update_buttons from
   //  indirectly causing potentially infinite recursion
  ++requests_pending_count;
  load_script(uri_toload);
  return;
}

//=========================================================================

function register_group (groupnum) {
  if(DEBUG) { alert("Registering group #" + groupnum.toString()) }

  --requests_pending_count;
  if(requests_pending_count == 0) {
    if( groupnum == current_group   ) { _update_buttons() }
    if( portal_mode_using_chardata ) { _update_portal()  }
  }
   // otherwise no point in updating, as we're still loading
  
  return;
}

//=========================================================================

var head;
function load_script (uri_to_js) {
  if(!head) { _get_head() }
  var script = document.createElement('script');
  script.src = uri_to_js;
  script.type = 'text/javascript';
  head.appendChild(script);
  return;
}

function _get_head () {
  if( document.getElementsByTagName ) {
    head = document.getElementsByTagName('head').item(0);
  } else if ( document.all ) {
    if( document.all['head'] ) {
      head = document.all['head'];
    } else {
      throw "I see no head in this document.all !";
    }
  } else {
    throw "I see no concievable way to find this document's head";
  }

  if(! head) { throw "Can't find head!?" }
  if(! head.appendChild ) { head = ''; throw "Can't insert a script element!?" }
  if(! document.createElement ) { head = ''; throw "Can't create elements?" }
  return;
}

//=========================================================================

function inserty (i) {
  _insert_a_char( String.fromCharCode( i * 1 + current_group * 256 ) );
  return;
}

function _insert_a_char (c) {
  if( ! c.length ){
    // nothing needs doing

  } else if( !smart_selection ) {
    // for simple browsers, act simple-minded.
    scratchy.value += c;

  } else {
    var sel_a = scratchy.selectionStart;
    var sel_b = scratchy.selectionEnd; // index of char right after range-end

    if( typeof(sel_a) == 'undefined' || typeof(sel_b) == 'undefined') {
      // Not a situation we can make sense of, so just append and run.
      scratchy.value += c;

    } else {
      // Normal case: insert and move the cursor
      scratchy.value = 
         scratchy.value.substr(0, sel_a)   // before selection/cursor
       + c
       + scratchy.value.substr(sel_b) // stuff after selection/cursor
      ;
      sel_a += c.length;
      scratchy.setSelectionRange( sel_a, sel_a );
    }
  }
  
  _update_portal();
  scratchy.focus();
  return;
}

//=========================================================================

function ev_space (f) { _insert_a_char( " "); ; _update_portal(); scratchy.focus(); return; }
function ev_ret   (f) { _insert_a_char("\n"); ; _update_portal(); scratchy.focus(); return; }
function ev_tab   (f) { _insert_a_char("\t"); ; _update_portal(); scratchy.focus(); return; }

//=========================================================================

function ev_clear (f) { scratchy.value  = ""  ; _update_portal(); scratchy.focus(); return; }

//=========================================================================

function ev_backspace (f) {
  // Yes, backspacing is surprisingly complex.

  if(scratchy.value.length == 0) {
    // no-op
    
  } else if( !smart_selection ) {
    // for simple browsers, act simple-minded: del last character of the thing
    scratchy.value = scratchy.value.substr(0, (scratchy.value.length - 1));
    _update_portal();

  } else {
    var sel_a = scratchy.selectionStart;
    var sel_b = scratchy.selectionEnd; // index of char right after range-end

    if( typeof(sel_a) == 'undefined' || typeof(sel_b) == 'undefined') {
      // Not a situation we can make sense of, so just append and run.
      scratchy.value += c;
      _update_portal();

    } else if( sel_a != sel_b ) {
      // Something is selected; simply delete it.
      scratchy.value = 
         scratchy.value.substr(0, sel_a)   // before selection/cursor
       + scratchy.value.substr(sel_b)      // after selection/cursor
      ;
      scratchy.setSelectionRange( sel_a, sel_a );
      _update_portal();

    } else if( sel_a == 0 ) {
      // Nothing selected, and we're at the start.  No-op.
    
    } else {
      // Normal case, so snip previous char and regress the cursor
      scratchy.value = 
         scratchy.value.substr(0, sel_a - 1 )
       + scratchy.value.substr(sel_a)
      ;
      scratchy.setSelectionRange( sel_a - 1, sel_a - 1 );
      _update_portal();
    }
  }
  scratchy.focus();
  return;
}

//=========================================================================

function ev_initdoc (f) {
  _init_pointers();
  _gen_buttons();
  _gen_pulldowns();
  _update_buttons();
  return;
}

function ev_update_portal (f) { _update_portal(); return; }

//=========================================================================

function _update_portal() {
  // update the portal
  if( portal_updater_function ) { portal_updater_function() }
  return;  
}
//=========================================================================

function _portal_esc_perl  () {
  if(DEBUG) alert("Updating Perl-esc portal...");
  
  portal.value = "[working]";
  var source = scratchy.value;
  var outval = '';
  var c;
  for(var i in source) {
    c = source.charCodeAt(i);
    if( c > 255 ) {
      // 					things to esc like \x{abcd}
      outval += "\\x{" + c.toString(16) + "}";
    } else if ( c > 126
      || ( c < 32 && c != 9 && c != 10 && c != 13 )
    ) {
      // 					things to esc like \xab
      outval += "\\x" + tohex_xx(c);
    } else if( c == 92 || c == 64 || c == 36 || c == 34 ) {
      // 					thing to esc like \_
      outval += "\\" + source.substr(i,1);
    } else {
      // 					just pass thru
      outval += source.substr(i,1);
    }
  }
  portal.value = outval;
  return;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function _portal_esc_js    () {
  if(DEBUG) alert("Updating JS-esc portal...");
  
  portal.value = "[working]";
  var source = scratchy.value;
  var outval = '';
  var c;
  for(var i in source) {
    c = source.charCodeAt(i);
    if( c > 255 ) {
      // 					things to esc like \uabcd
      outval += "\\u" + tohex_xxxx(c);
    } else if ( c > 126
      || ( c < 32 && c != 9 && c != 10 && c != 13 )
    ) {
      // 					things to esc like \xab
      outval += "\\x" + tohex_xx(c);
    } else if( c == 92 || c == 39 || c == 34 ) {
      //					things to esc like \_
      outval += "\\" + source.substr(i,1);
    } else {
      // 					just pass thru
      outval += source.substr(i,1);
    }
  }
  portal.value = outval;
  return;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
function _portal_esc_xml   () {
  if(DEBUG) alert("Updating XML-esc portal...");
  
  portal.value = "[working]";
  var source = scratchy.value;
  var outval = '';
  var c;
  for(var i in source) {
    c = source.charCodeAt(i);
    if(      c > 126
         || (c == 38 || c == 60 || c == 62 )
         || !( c ==  9 || c == 10 || c == 13 || c >= 32 )
    ) {
      outval += "&#x" + c.toString(16) + ";"; // have to esc
    } else {
      outval += source.substr(i,1); // just pass thru
    }
  }
  portal.value = outval;
 
  return;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function _portal_unidecode () {
  if(DEBUG) alert("Updating Unidecode portal...");
  
  portal.value = "[working]";
  var source = scratchy.value;
  var outval = '';
  for(var i in source) {
    outval += Unchar( source.charCodeAt(i) );
  }
  
  portal.value = outval;
  return;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function _portal_unicode_details () {
  if(DEBUG) alert("Updating Unicode details portal...");
  
  portal.value = "[working]";
  var source = scratchy.value;
  var outval = '';
  var num;
  var c;
  for(var i in source) {
    c = source.charCodeAt(i);
    num = c.toString();
    while( num.length < 5) { num = "0" + num; }
    outval +=  "Char " + num + " | U+"
     + tohex_xx(c) + " | " + CharnC( c )  + "\n";
  }
  
  portal.value = outval;
  
  // TODO: mirror the selectionstart thingy of the input space?
  if( "textLength"     in portal && portal.textLength
      && "selectionStart" in portal
      && "selectionEnd"   in portal
      && "setSelectionRange" in portal
  ) {
    //portal.selectionStart = portal.textLength;
    //portal.selectionEnd   = portal.textLength;
    portal.setSelectionRange( portal.textLength, portal.textLength );
  }
  return;
}

//=========================================================================

function ev_set_portal_mode (f) {
  var m = portalmode_picker.value;
  portal_mode_using_chardata = false;
  
  switch(m) {
    case "esc_perl" :
      portal_updater_function = _portal_esc_perl;
      break;
    case "esc_js" :
      portal_updater_function = _portal_esc_js;
      break;
    case "esc_xml" :
      portal_updater_function = _portal_esc_xml;
      break;
    case "uchar" :
      portal_updater_function = _portal_unicode_details;
      portal_mode_using_chardata = true;
      break;
    default :
      portal_updater_function = _portal_unidecode;
      portal_mode_using_chardata = true;
      break;
  }
  
  if(DEBUG) alert("Portal mode is now " + portalmode_picker.value);
  _update_portal();
  
  return;
}

//=========================================================================
//  utility functions

function exists(object, key) { return (typeof object[key] != 'undefined') }

var has               = {};
has["all"]            = exists(document, "all");
has["getElementById"] = exists(document, "getElementById");
has["style"]          = exists(new Image(), "style");
has["display"]        = has.style && exists(new Image().style, "display");
has["innerHTML"]      = exists(document, "innerHTML");
has["javascript2"]    = has.getElementById && has.style && has.innerHTML;

function id(name) {
  var object = has.getElementById ? document.getElementById(name) // Standards (prefered)
    : has.all ? document.all[name]                          // Older IE
    : null;
  if ( DEBUG && ! object ) alert("Failed to find element with id '" + name + "'");
    return object;
}


//=========================================================================
// End.

